	device zxspectrum128
        ORG #8000
;---------------------------------definitions-----------------------------------
 include "opcodes.inc"

;;;;;;;;;;;;;;;;;;;interrupts
 macro wait_int
 db HG_
 endm

 macro int_on
 db OL_
 endm

 macro int_off
 db OD_
 endm

;;;;;;;;;;;;;;;;; load reg16,immediate
 macro ldbc imm16
 db B_
 db imm16&255
 db imm16/256
 endm

 macro ldde imm16
 db BB_
 db imm16&255
 db imm16/256
 endm

 macro ldhl imm16
 db CB_
 db imm16&255
 db imm16/256
 endm

 macro moveb
  db PN_
  db LA_
 endm
 
 macro exd
  db PL_
 endm
;;;;;;;;;stack push/pop regpair16
 macro pshbc
 db MF_
 endm

 macro popbc
 db MB_
 endm
 
 macro pshhl
  db PF_
 endm
 
 macro pophl
 db PB_
 endm
;;;;;;;;ld(reg16),reg8
 macro ldmhla
 db HH_
 endm
;;;;;;;;;;;;ld reg,reg 8bit
 macro lddb
 db FA_
 endm

 macro ldal
 db HN_
 endm

 macro ldhc
 db GB_
 endm
 
 macro ldea
 db FO_
 endm

 macro ldel
 db FN_
 endm

 macro ldld
 db GK_
 endm
;;;; add reg16,reg16
 macro addhlhl
 db CJ_
 endm

 macro addhlde
 db BJ_
 endm

;;;;;;;;;bitwise ops direct
 macro band num
 db PG_
 db num
 endm
;;;ld reg8, imm
 macro ldbi imm
 db G_
 db imm
 endm
;;;inc reg8
 macro incl
 db CM_
 endm

 macro incc
 db M_
 endm
;;bitwise or/and/xor reg8
 macro eorb
 db KI_
 endm

 macro eorc
 db KJ_
 endm
;;;;;;;cmp reg8 immediate value
 macro cpa imm
 db OP_
 db imm
 endm
;conditional branches
 macro bcc branch;CY=0
 db DI_
 db (branch-$-1)&255
 endm
 
 macro bcs branch;CY=1
 db DA_
 IF branch>$
 db (branch-$-1)&255
 ELSE
 db ($-branch-1)&255
 ENDIF
 endm
 
 macro loopb branch
 db BA_
 IF branch>$
 db ($-1-branch)&255
 ELSE
 db (branch-$-1)&255
 ENDIF
 endm
 
 macro bra branch
 db BI_
 IF branch>$
 db ($-1-branch)&255
 ELSE
 db (branch-$-1)&255
 ENDIF
 endm
 
 macro beq branch
 db CI_
 IF branch>$
 db ($-1-branch)&255
 ELSE
 db (branch-$-1)&255
 ENDIF
 endm
 
 macro bne branch
 db CA_
 IF branch>$
 db ($-1-branch)&255
 ELSE
 db (branch-$-1)&255
 ENDIF
 endm
;-----------------------------------demo----------------------------------------
begin
 int_on;ei
dointro:
 pshbc
 ldhl #5820
 ldde #5800
 ldbc #2E0
 wait_int
 moveb

 exd;hl=#5aE0
 lddb
 popbc
lp1:
 ldal
 band BO_
 
 pshhl
 ldhc
 ldea

  ldel
Mul8b:; this routine performs the operation HL=H*E
; clearing D and L
  ldld
  ldbi 8;we have 8 bits
Mul8bLoop:
  addhlhl;advancing a bit
  
  bcs Mul8bSkip;if zero, we skip the addition (jp is used for speed)
  addhlde;adding to the product if necessary
Mul8bSkip:
 loopb Mul8bLoop
 ;b=0
 ldal
 band BO_
 cpa BA_
 bcc putval
 ldbi DO_
putval:
 pophl
 ldal
 eorc
 eorb
 band DO_
 ldmhla

 incl
 bne lp1
 incc
 bra dointro

end
	display /d,end-begin
	savebin "pat.bin",begin,end-begin
	savesna "!pat.sna",begin

